require "import"
import "android.widget.*"
import "android.view.*"
import "android.app.*"
import "android.provider.ContactsContract"
import "java.util.*"

local activity = activity
local contactList = {}

function onCreate(savedInstanceState)
    activity.setTitle("Speed Dial")
    local layout = LinearLayout(activity)
    layout.setOrientation(1)

    local contactsLayout = LinearLayout(activity)
    contactsLayout.setOrientation(1)
    layout.addView(contactsLayout)

    local cursor = activity.getContentResolver().query(ContactsContract.Contacts.CONTENT_URI, nil, nil, nil, nil)
    while cursor.moveToNext() do
        local id = cursor.getString(cursor.getColumnIndex(ContactsContract.Contacts._ID))
        local name = cursor.getString(cursor.getColumnIndex(ContactsContract.Contacts.DISPLAY_NAME))
        local phoneNumber = getPhoneNumber(id)

        local contactLayout = LinearLayout(activity)
        contactLayout.setOrientation(0)

        local nameTextView = TextView(activity)
        nameTextView.setText(name)
        nameTextView.setTextSize(16)
        contactLayout.addView(nameTextView)

        local callButton = Button(activity)
        callButton.setText("Call")
        callButton.setOnClickListener{
            onClick = function(v)
                callContact(phoneNumber)
            end
        }
        contactLayout.addView(callButton)

        contactsLayout.addView(contactLayout)
        table.insert(contactList, {name = name, phoneNumber = phoneNumber})
    end
    cursor.close()

    activity.setContentView(layout)
end

function getPhoneNumber(contactId)
    local cursor = activity.getContentResolver().query(ContactsContract.CommonDataKinds.Phone.CONTENT_URI, nil, ContactsContract.CommonDataKinds.Phone.CONTACT_ID .. " = ?", {contactId}, nil)
    if cursor.moveToFirst() then
        local phoneNumber = cursor.getString(cursor.getColumnIndex(ContactsContract.CommonDataKinds.Phone.NUMBER))
        cursor.close()
        return phoneNumber
    end
    cursor.close()
    return nil
end

function callContact(phoneNumber)
    local intent = Intent(Intent.ACTION_CALL)
    intent.setData(Uri.parse("tel:" .. phoneNumber))
    activity.startActivity(intent)
end